package cn.com.qmth.examcloud.core.oe.student.controller;

import java.util.List;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.student.bean.ObjectiveScoreInfo;
import cn.com.qmth.examcloud.core.oe.student.service.ExamScoreService;

/**
 * 
 * @author  	chenken
 * @date    	2018年10月20日 下午3:33:26
 * @company 	QMTH
 * @description ExamScoreController.java
 */
@Api(tags = "分数相关接口")
@RestController
@RequestMapping("${app.api.oe.student}/examScore")
public class ExamScoreController {
	
	@Autowired
	private ExamScoreService examScoreService;
	
	@ApiOperation(value = "根据examStudentId获取客观分信息")
	@GetMapping("/queryObjectiveScoreList")
	public List<ObjectiveScoreInfo> queryObjectiveScoreList(@RequestParam Long examStudentId){
		Check.isNull(examStudentId, "examStudentId 不能为空");
		return examScoreService.queryObjectiveScoreList(examStudentId);
	}
	
}
