package cn.com.qmth.examcloud.core.oe.student.provider;

import cn.com.qmth.examcloud.core.oe.admin.api.OeExamStudentCloudService;
import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordPaperStructEntity;
import cn.com.qmth.examcloud.core.oe.student.api.OeExamPaperStructCloudService;
import cn.com.qmth.examcloud.core.oe.student.api.request.GetExamRecordPaperStructReq;
import cn.com.qmth.examcloud.core.oe.student.api.response.GetExamRecordPaperStructResp;
import cn.com.qmth.examcloud.core.oe.student.service.ExamRecordPaperStructService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Api(tags = "考试记录-试卷结构")
@RestController
@RequestMapping("${$rmp.cloud.oe.student}" + "examRecordPaperStruct")
public class ExamRecordPaperStructProvider extends ControllerSupport implements OeExamPaperStructCloudService {

	@Autowired
	private ExamRecordPaperStructService examRecordPaperStructService;
	
	@ApiOperation(value = "获取考试记录试卷结构")
	@PostMapping("/getExamRecordPaperStruct")
	@Override
	public GetExamRecordPaperStructResp getExamRecordPaperStruct(@RequestBody GetExamRecordPaperStructReq req) {
		Check.isNull(req.getExamRecordDataId(), "考试记录id不能为空");
		ExamRecordPaperStructEntity examRecordPaperStructEntity = examRecordPaperStructService.getExamRecordPaperStruct(req.getExamRecordDataId());
		GetExamRecordPaperStructResp resp = new GetExamRecordPaperStructResp();
		if (null == examRecordPaperStructEntity){
			return null;
		}
		resp.setDefaultPaper(examRecordPaperStructEntity.getDefaultPaper());
		return resp;
	}
}
