package cn.com.qmth.examcloud.core.oe.student.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordForMarkingEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordForMarkingRepo;
import cn.com.qmth.examcloud.core.oe.student.api.OeExamRecordForMarkingCloudService;
import cn.com.qmth.examcloud.core.oe.student.api.request.SaveExamRecordForMarkingReq;
import cn.com.qmth.examcloud.core.oe.student.service.ExamRecordQuestionsService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;


@Api(tags = "保存阅卷数据接口")
@RestController
@RequestMapping("${$rmp.cloud.oe.student}" + "examRecordForMarking")
public class OeExamRecordForMarkingCloudServiceProvider extends ControllerSupport implements OeExamRecordForMarkingCloudService{

	/**
	 * 
	 */
	private static final long serialVersionUID = 5991001721278000904L;

	@Autowired
	private ExamRecordQuestionsService examRecordQuestionsService;
	
	@Autowired
	private ExamRecordForMarkingRepo examRecordForMarkingRepo;
	
	@Override
	@PostMapping("/saveExamRecordForMarking")
	public void saveExamRecordForMarking(@RequestBody SaveExamRecordForMarkingReq req) {
		ExamRecordForMarkingEntity examRecordForMarkingExists = examRecordForMarkingRepo.findByExamRecordDataId(req.getExamRecordDataId());
		if(examRecordForMarkingExists != null){
			return;
		}
		ExamRecordForMarkingEntity examRecordForMarking = new ExamRecordForMarkingEntity();
        examRecordForMarking.setExamId(req.getExamId());
        examRecordForMarking.setExamRecordDataId(req.getExamRecordDataId());
        examRecordForMarking.setExamStudentId(req.getExamStudentId());
        examRecordForMarking.setBasePaperId(req.getBasePaperId());
        examRecordForMarking.setPaperType(req.getPaperType());
        examRecordForMarking.setCourseId(req.getCourseId());
        examRecordForMarking.setObjectiveScore(req.getObjectiveScore());
        int subjectiveAnswerLength = examRecordQuestionsService.calculationSubjectiveAnswerLength(req.getExamRecordDataId());
        examRecordForMarking.setSubjectiveAnswerLength(subjectiveAnswerLength);
        examRecordForMarkingRepo.save(examRecordForMarking);
	}

}
