package cn.com.qmth.examcloud.core.oe.student.provider;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.Date;
import java.util.List;
import java.util.Optional;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.util.OKHttpUtil;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamScoreNoticeQueueEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.OrgScoreHandleEntity;
import cn.com.qmth.examcloud.core.oe.common.info.NotifyUrlInfo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreNoticeQueueRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.OrgScoreHandleRepo;
import cn.com.qmth.examcloud.core.oe.common.service.ExamScoreNoticeQueueService;
import cn.com.qmth.examcloud.core.oe.common.service.ExamScoreObtainQueueService;
import cn.com.qmth.examcloud.core.oe.student.api.OeExamScoreNoticeQueueCloudService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@Api(tags = "定时发送获取分数通知接口")
@RestController
@RequestMapping("${$rmp.cloud.oe.student}" + "examScoreNoticeQueue")
public class OeExamScoreNoticeQueueCloudServiceProvider extends ControllerSupport
		implements OeExamScoreNoticeQueueCloudService {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2622841462905285211L;

//	@Autowired
//	private OrgScoreHandleRepo orgScoreHandleRepo;
	@Autowired
	private ExamScoreNoticeQueueRepo examScoreNoticeQueueRepo;
	@Autowired
	ExamScoreObtainQueueService examScoreObtainQueueService;

	/**
	 * 定时发送分数获取通知 定时任务每5分钟发送一次
	 */
	@ApiOperation(value = "定时发送获取分数通知接口")
	@PostMapping("/sendObtainScoreNotice")
	@Override
	public void sendObtainScoreNotice() {
		System.out.println("1开始执行sendObtainScoreNotice");
		log.info("开始执行sendObtainScoreNotice");
		// 获取所有的通知队列
		List<ExamScoreNoticeQueueEntity> examScoreNoticeQueueList = examScoreNoticeQueueRepo.findAll();
		if (examScoreNoticeQueueList == null || examScoreNoticeQueueList.size() == 0) {
			return;
		}
		System.out
				.println("2执行sendObtainScoreNotice，examScoreNoticeQueueList.size()=" + examScoreNoticeQueueList.size());
		// 获取所有配置通知路径的组织机构集合
//		List<OrgScoreHandleEntity> orgScoreHandleList = orgScoreHandleRepo.findEnableNotifyItems();
//		
//		if(orgScoreHandleList == null || orgScoreHandleList.size() == 0){
//			return;
//		}
//		System.out.println("3执行sendObtainScoreNotice，orgScoreHandleList.size()="+orgScoreHandleList.size());
		for (ExamScoreNoticeQueueEntity noticeEntity : examScoreNoticeQueueList) {
			// 获取当前组织机构的通知对象
			NotifyUrlInfo notifyUrlInfo = examScoreObtainQueueService.getNotifyUrlInfo(noticeEntity.getRootOrgId());
//			找到当前组织机构对应的通知队列 ldy20190516代码重构，修改获取通知方式
//			Optional<OrgScoreHandleEntity> optionalOrgScoreHandle = orgScoreHandleList.stream().filter(org->org.getRootOrgId().equals(noticeEntity.getRootOrgId())).findFirst();
//			if(optionalOrgScoreHandle.isPresent()) {
//				OrgScoreHandleEntity orgScoreHandle = optionalOrgScoreHandle.get();
			// 只有配置了通知接口的才发送通知
			if (StringUtils.isNotBlank(notifyUrlInfo.getNotifyUrl())) {
				try {
					OKHttpUtil.call(notifyUrlInfo.getHttpMethod(), notifyUrlInfo.getNotifyUrl());
//						this.post(notifyUrlInfo.getNotifyUrl(), null, 2000,15000);
					// 发送通知没有问题，则清除通知队列中数据
					examScoreNoticeQueueRepo.deleteById(noticeEntity.getRootOrgId());
				} catch (Exception e) {
					if (e instanceof UnknownHostException || e instanceof SocketException) {
						try {
							// 如果是由于连接超时,或者读取数据超时导致异常,需要对发送通知失败次数进行累加
							long failTimes = noticeEntity.getFailTimes() == null ? 0
									: noticeEntity.getFailTimes().longValue();
							noticeEntity.setFailTimes(failTimes + 1);
							noticeEntity.setUpdateTime(new Date());
							examScoreNoticeQueueRepo.save(noticeEntity);
						} catch (Exception e1) {
							log.error("examScoreNoticeQueueRepo.save exception:" + e1.getMessage(), e1);
						}
					}
					log.error("OeExamScoreNoticeQueueCloudServiceProvider-sendObtainScoreNotice:" + e.getMessage(), e);
				}
			}
//			}

		}
		log.info("结束执行sendObtainScoreNotice");
		System.out.println("结束执行sendObtainScoreNotice");
	}

}
