package cn.com.qmth.examcloud.core.oe.student.provider;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import cn.com.qmth.examcloud.core.oe.common.base.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamScoreNoticeQueueEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamScoreObtainQueueEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreNoticeQueueRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreObtainQueueRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.OrgScoreHandleRepo;
import cn.com.qmth.examcloud.core.oe.student.api.OeExamScoreObtainQueueCloudService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@Api(tags = "获取分数队列")
@RestController
@RequestMapping("${$rmp.cloud.oe.student}" + "examScoreObtainQueue")
public class OeExamScoreObtainQueueCloudServiceProvider extends ControllerSupport implements OeExamScoreObtainQueueCloudService{

	/**
	 * 
	 */
	private static final long serialVersionUID = -2622841462905285211L;
	
	@Autowired
	private OrgScoreHandleRepo orgScoreHandleRepo;
	@Autowired
	ExamScoreObtainQueueRepo examScoreObtainQueueRepo;
	@Autowired
	ExamScoreNoticeQueueRepo examScoreNoticeQueueRepo;
	
	/**
	 * 定时更新获取分数通知队列
	 * 
	 */
	@ApiOperation(value = "定时更新获取分数通知队列")
	@PostMapping("/updateObtainScoreNodifyQueue")
	@Override
	public void updateObtainScoreNodifyQueue() {
		Date now = new Date();
		Date twoHoursBefore= DateUtils.addHours(now, -2);
		//1.查找超过创建超过2小时,且通知队列中不存在的待获取的数据
		List<ExamScoreObtainQueueEntity> toObtainQueueList = examScoreObtainQueueRepo.findByCreationTimeLessThanEquals(twoHoursBefore);
		//1.1如果不存在，不作任何处理
		if(toObtainQueueList==null || toObtainQueueList.isEmpty()) {
			return;
		}
		//1.2如果存在,则创建相应组织机构的通知队列
		List<Long> rootOrgList = toObtainQueueList.stream().map(ExamScoreObtainQueueEntity::getRootOrgId).distinct().collect(Collectors.<Long>toList());
		List<ExamScoreNoticeQueueEntity> noticeQueueEntityList= new ArrayList<ExamScoreNoticeQueueEntity>(); 
		rootOrgList.forEach(ro->{
			ExamScoreNoticeQueueEntity noticeQueueEntity = new ExamScoreNoticeQueueEntity();
			noticeQueueEntity.setRootOrgId(ro);
			noticeQueueEntity.setCreationTime(now);
			noticeQueueEntityList.add(noticeQueueEntity);
		});
		//批量插入通知队列
		examScoreNoticeQueueRepo.saveAll(noticeQueueEntityList);
//		List<OrgScoreHandleEntity> orgScoreHandleList = orgScoreHandleRepo.findEnableNotifyItems();
//		if(orgScoreHandleList == null || orgScoreHandleList.size() == 0){
//			return;
//		}
//		for(OrgScoreHandleEntity orgScoreHandle:orgScoreHandleList){
//			if(StringUtils.isNotBlank(orgScoreHandle.getNotifyUrl())){
//				try{
//					HttpClientUtil.post(orgScoreHandle.getNotifyUrl(), null, 2000);
//				}catch(Exception e){
//					log.error("ExamScoreObtainQueueServiceImpl-sendNotifyError:"+e.getMessage(),e);
//				}
//			}
//		}
	}

}
