package cn.com.qmth.examcloud.core.oe.student.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.student.api.OeHandleByExamCaptureQueueFailedDisposeService;
import cn.com.qmth.examcloud.core.oe.student.api.request.HandleByExamCaptureQueueFailedDisposeReq;
import cn.com.qmth.examcloud.core.oe.student.service.ExamControlService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;


@Api(tags = "抓拍照片失败处理")
@RestController
@RequestMapping("${$rmp.cloud.oe.student}" + "handleByExamCaptureQueueFailedDispose")
public class OeHandleByExamCaptureQueueFailedDisposeServiceProvider extends ControllerSupport implements OeHandleByExamCaptureQueueFailedDisposeService{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4864914290302594216L;

	@Autowired
	private ExamControlService examControlService;
	
	@ApiOperation(value = "抓拍照片失败处理")
	@Override
	@PostMapping
	public void handleByExamCaptureQueueFailedDispose(@RequestBody HandleByExamCaptureQueueFailedDisposeReq req) {
		Check.isNull(req.getExamRecordDataId(), "examRecordDataId 不能为空");
		examControlService.handleByExamCaptureQueueFailedDispose(req.getExamRecordDataId());
	}

}
