package cn.com.qmth.examcloud.core.oe.student.bean;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamingRecordEntity;

/**
 * @Description 清理考试记录优先级队列实体
 * @Author lideyin
 * @Date 2019/8/11 13:51
 * @Version 1.0
 */
public class CleanExamRecordPriorityQueueInfo implements Comparable<CleanExamRecordPriorityQueueInfo> {

    private int priority;
    private ExamingRecordEntity examingRecord;

    public CleanExamRecordPriorityQueueInfo() {
    }
    public CleanExamRecordPriorityQueueInfo(int priority, ExamingRecordEntity examingRecord) {
        this.priority = priority;
        this.examingRecord = examingRecord;
    }

    public int getPriority() {
        return priority;
    }

    public void setPriority(int priority) {
        this.priority = priority;
    }

    public ExamingRecordEntity getExamingRecord() {
        return examingRecord;
    }

    public void setExamingRecord(ExamingRecordEntity examingRecord) {
        this.examingRecord = examingRecord;
    }

    //升序
    @Override
    public int compareTo(CleanExamRecordPriorityQueueInfo data) {
        return this.priority > data.priority ? -1 : this.priority == data.priority ? 0 : 1;
    }

    //考试记录id 相同则认为是同一个对象
    @Override
    public boolean equals(Object o) {
        if (this.examingRecord==null){
            return false;
        }
        return this.examingRecord.getId()
                .equals(((CleanExamRecordPriorityQueueInfo) o).getExamingRecord().getId());
    }
}
