package cn.com.qmth.examcloud.core.oe.student.service;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamFaceLivenessVerifyEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.student.bean.GetFaceVerifyTokenInfo;

import java.util.List;


/**
 * @author  	chenken
 * @date    	2018年2月5日 上午8:44:19
 * @company 	QMTH
 * @description 活体检测服务接口
 */
public interface ExamFaceLivenessVerifyService {
	
	/**
	 * 保存活体检测信息
	 * @param examRecordDataId
	 */
	public ExamFaceLivenessVerifyEntity saveFaceVerify(Long examRecordDataId);
	/**
	 * 使用考试记录id查询人脸活体检测信息
	 * @param examRecordDataId
	 * @return
	 */
	public List<ExamFaceLivenessVerifyEntity> listFaceVerifyByExamRecordId(Long examRecordDataId);
	/**
	 * 人脸检测完成后回调处理
	 * @param resultJson
	 * @return
	 */
	public ExamFaceLivenessVerifyEntity faceIdNotify(String resultJson);
	/**
	 * 向faceId发起检测请求，返回token
	 * @param examRecordDataId
	 * @return
	 */
	public GetFaceVerifyTokenInfo getFaceVerifyToken(Long studentId,String bizNo);
	
	public ExamFaceLivenessVerifyEntity saveFaceVerifyByExamRecordDataId(Long examRecordDataId);
	
	/**
	 * 根据ID查询
	 * @param id
	 * @return
	 */
	public ExamFaceLivenessVerifyEntity findFaceVerifyById(Long id);
	
	/**
	 * 人脸检测超时处理
	 * @param examRecordDataId
	 */
	public void faceTestTimeOut(Long examRecordDataId);
	/**
	 * 人脸活体检测结束处理
	 * @param examRecordDataId
	 * @param  studentId
	 * @param result
	 */
	public void faceTestEndHandle(Long examRecordDataId,Long studentId, String result);
	/**
	 * 断点续考，获取活体检测开启时间
	 * @param examId
	 * @param examRecordDataId
	 * @param heartbeat
	 * @return
	 */
	public Integer getFaceLivenessVerifyMinute(Long orgId,Long examId,Long examRecordDataId, Integer heartbeat);
	
}

