package cn.com.qmth.examcloud.core.oe.student.service;


import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordQuestionsEntity;
import cn.com.qmth.examcloud.core.oe.student.bean.ExamStudentQuestionInfo;
import cn.com.qmth.examcloud.question.commons.core.paper.DefaultPaper;
import cn.com.qmth.examcloud.question.commons.core.question.DefaultQuestionStructure;

import java.util.List;

/**
 * 
 * @author  	chenken
 * @date    	2018年9月3日 上午10:56:56
 * @company 	QMTH
 * @description 考试记录-作答归档服务接口
 */
public interface ExamRecordQuestionsService {

	/**
	 * 计算主观题作答总长度
	 * @param examRecordDataId
	 * @return
	 */
	Integer calculationSubjectiveAnswerLength(Long examRecordDataId);

	/**
	 * 初始化ExamQuestion
	 * @param examRecordDataId
	 * @param paperStructByReorder
	 */
	ExamRecordQuestionsEntity createExamRecordQuestions(Long examRecordDataId, DefaultPaper paperStructByReorder);

	/**
	 * 获取考试作答记录并修复考试记录表的数据(如有必要)
	 * @param examRecordData 考试记录
	 * @return
	 */
    ExamRecordQuestionsEntity getExamRecordQuestionsAndFixExamRecordDataIfNecessary(ExamRecordDataEntity examRecordData);

	/**
	 *  获取考试作答记录并修复考试记录表的数据(如有必要)
	 * @param examRecordDataId 考试记录id
	 * @return
	 */
	ExamRecordQuestionsEntity getExamRecordQuestionsAndFixExamRecordDataIfNecessary(Long examRecordDataId);

	void submitQuestionAnswer(Long studentId, List<ExamStudentQuestionInfo> examQuestionInfos);

	String getQuestionContent(Long studentId, String questionId);
}
