package cn.com.qmth.examcloud.core.oe.student.service;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamScoreEntity;
import cn.com.qmth.examcloud.core.oe.student.bean.ObjectiveScoreInfo;

import java.util.List;


/**
 * 
 * @author  	chenken
 * @date    	2018年9月3日 上午9:54:31
 * @company 	QMTH
 * @description 考试分数接口
 */
public interface ExamScoreService {

	
	public ExamScoreEntity saveExamScore(ExamRecordDataEntity examRecordData);
	
	/**
	 * 离线考试初始化得分
	 * @param examRecordDataId
	 */
	public void createExamScoreWithOffline(Long examRecordDataId);
	
	/**
	 * 使用考生ID查询有效考试记录的成绩
	 * @return
	 */
	public List<ExamScoreEntity> queryExamScoreListByExamStudentId(Long examStudentId);
	
	/**
	 * 使用考生ID查询客观分信息 
	 * 客观分是指考生完成过一次考试后，有效的客观分，
	 * 如此条考试记录需要监考审核则显示为"待审"，客观分显示时，展示次数(第几次考试)、开始时间、交卷时间，客观分；
	 * @return
	 */
	public List<ObjectiveScoreInfo> queryObjectiveScoreList(Long examStudentId);
	
}
