package cn.com.qmth.examcloud.core.oe.student.service;

import java.util.List;

import cn.com.qmth.examcloud.core.oe.student.bean.ExamStudentInfo;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamStudentEntity;
import cn.com.qmth.examcloud.examwork.api.bean.ExamBean;

/**
 * 
 * @author  	chenken
 * @date    	2018年8月13日 下午2:45:21
 * @company 	QMTH
 * @description 考生服务接口
 */
public interface ExamStudentService {

	/**
	 * 获取在线考试待考列表
	 * @param studentId
	 * @return
	 */
	public List<ExamStudentInfo> queryOnlineExamList(Long studentId);
	
	/**
	 * 统计剩余考试次数
	 * @param examStudentInfo
	 * @return
	 */
	public Integer countExamTimes(ExamStudentEntity examStudentInfo,ExamBean examBean);

	/**
	 * 开始考试时，更新考生信息,并返回已考的考试次数
	 * @param id 考生主键id
	 * @param isReExamine 是否重考
	 * @param reExamineCompleted 重考是否完成
	 * @param normalExamTimes 已考次数
	 * @param examBean 考试实体
	 * @return int 已考的考试次数
	 */
	public int updateExamStudentByStartExam(Long id,Boolean isReExamine,Boolean reExamineCompleted,
														  Integer normalExamTimes, final ExamBean examBean);
}
