package cn.com.qmth.examcloud.core.oe.student.service.impl;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamingRecordEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamingRecordRepo;
import cn.com.qmth.examcloud.core.oe.student.bean.CleanExamRecordPriorityQueueInfo;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.PriorityBlockingQueue;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

public class CleanExamRecordQueueHolder {
    public static final int HIGH_PRIORITY=1;
    public static final int LOW_PRIORITY=0;
    private static final BlockingQueue<CleanExamRecordPriorityQueueInfo> priorityQueue = new PriorityBlockingQueue<>();

    /**
     * 如果队列中数据不存在，则向队列添加数据，默认超时时间10秒
     *
     * @param element 数据对象
     * @return boolean
     */
    public static boolean offer(CleanExamRecordPriorityQueueInfo element) throws InterruptedException {
        return priorityQueue.offer(element, 10, TimeUnit.SECONDS);
    }

//    /**
//     * 从队列中获取指定数量的考试记录id
//     * @param limitNum 数量
//     * @return List<ExamRecordDataEntity>
//     */
//    public static List<ExamingRecordEntity> getLimtExamRecordDataListFromQueue(int limitNum) throws InterruptedException {
//        //如果除外中不足 limitNum条数据，则从数据库中查询limitNum条数据至队列中
//        if (priorityQueue.size()<limitNum){
//            ExamingRecordRepo examingRecordRepo = SpringContextHolder.getBean(ExamingRecordRepo.class);
//            List<ExamingRecordEntity> examingRecordList = examingRecordRepo.findLimitExamingRecordList(limitNum);
//            for (ExamingRecordEntity record:examingRecordList){
//                CleanExamRecordPriorityQueueInfo info = new CleanExamRecordPriorityQueueInfo();
//                //数据库中取出来的数据，默认低优先级处理
//                info.setPriority(LOW_PRIORITY);
//                info.setExamingRecord(record);
//                if (!offer(info)){
//                    throw new StatusException("100001","向清理考试队列中添加数据失败");
//                }
//            }
//        }
//        List<CleanExamRecordPriorityQueueInfo> priorityQueueInfoList = new ArrayList<>();
//        priorityQueue.drainTo(priorityQueueInfoList,limitNum);
//        return priorityQueueInfoList.stream()
//                .map(CleanExamRecordPriorityQueueInfo::getExamingRecord)
//                .collect(Collectors.toList());
//    }
}
