package cn.com.qmth.examcloud.core.oe.student.service.impl;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordForMarkingEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamScoreEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordDataRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordForMarkingRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreRepo;
import cn.com.qmth.examcloud.core.oe.student.service.ExamRecordForMarkingService;
import cn.com.qmth.examcloud.core.oe.student.service.ExamRecordQuestionsService;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;
import main.java.com.UpYun;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service("examRecordForMarkingService")
public class ExamRecordForMarkingServiceImpl implements ExamRecordForMarkingService {

	@Autowired
	private ExamRecordQuestionsService examRecordQuestionsService;
	
	@Autowired
	private ExamRecordForMarkingRepo examRecordForMarkingRepo;
	
	@Autowired
	private ExamRecordDataRepo examRecordDataRepo;
	
	@Autowired
	private ExamScoreRepo examScoreRepo;

	@Value("${$upyun.site.1.bucketName}")
    private String bucketName;
	
	@Value("${$upyun.site.1.userName}")
	private String userName;
	
	@Value("${$upyun.site.1.password}")
	private String password;

	@Value("${$upyun.site.1.domain}")
	private String upyunFileUrl;

	@Override
	public void saveExamRecordForMarking(Long examRecordDataId) {
		ExamRecordDataEntity examRecordData = GlobalHelper.getEntity(examRecordDataRepo, examRecordDataId, ExamRecordDataEntity.class);
		ExamScoreEntity examScore = examScoreRepo.findByExamRecordDataId(examRecordDataId);
		saveExamRecordForMarking(examRecordData, examScore.getObjectiveScore());
	}

	@Override
	public void saveExamRecordForMarking(ExamRecordDataEntity examRecordData,double objectiveQuestionTotalScore) {
		//全客观题卷
    	if(examRecordData.getIsAllObjectivePaper()){
    		return;
    	}
    	//违纪
    	if(examRecordData.getIsIllegality()){
    		return;
    	}
    	//有警告未审核
    	if(examRecordData.getIsWarn()&&!examRecordData.getIsAudit()){
    		return;
    	}
    	//已经存在
    	ExamRecordForMarkingEntity examRecordForMarkingExists = examRecordForMarkingRepo.findByExamRecordDataId(examRecordData.getId());
    	if(examRecordForMarkingExists != null){
    		return;
    	}


		ExamRecordForMarkingEntity examRecordForMarking = new ExamRecordForMarkingEntity();
        examRecordForMarking.setExamId(examRecordData.getExamId());
        examRecordForMarking.setExamRecordDataId(examRecordData.getId());
        examRecordForMarking.setExamStudentId(examRecordData.getExamStudentId());
        examRecordForMarking.setBasePaperId(examRecordData.getBasePaperId());
        examRecordForMarking.setPaperType(examRecordData.getPaperType());
        examRecordForMarking.setCourseId(examRecordData.getCourseId());
        examRecordForMarking.setObjectiveScore(objectiveQuestionTotalScore);

        int subjectiveAnswerLength = examRecordQuestionsService.calculationSubjectiveAnswerLength(examRecordData.getId());
        examRecordForMarking.setSubjectiveAnswerLength(subjectiveAnswerLength);

        examRecordForMarkingRepo.save(examRecordForMarking);
	}

	@Override
	public void saveOffLineExamRecordForMarking(ExamRecordDataEntity examRecordData,String offlineFileName,String fileUrl) {
		ExamRecordForMarkingEntity examRecordForMarking = examRecordForMarkingRepo.findByExamRecordDataId(examRecordData.getId());
		if(examRecordForMarking == null){
			examRecordForMarking = new ExamRecordForMarkingEntity();
			examRecordForMarking.setCreationTime(new Date());
		}else{
			//将原文件删掉
			UpYun upyun = new UpYun(bucketName,userName,password);
			String offlineFileUrl = examRecordForMarking.getOfflineFileUrl();
			offlineFileUrl = offlineFileUrl.replace(upyunFileUrl,"");
			upyun.deleteFile(offlineFileUrl);
		}

        examRecordForMarking.setExamId(examRecordData.getExamId());
        examRecordForMarking.setExamRecordDataId(examRecordData.getId());
        examRecordForMarking.setExamStudentId(examRecordData.getExamStudentId());
        examRecordForMarking.setCourseId(examRecordData.getCourseId());
        examRecordForMarking.setOfflineFileUrl(fileUrl);
        examRecordForMarking.setOfflineFileName(offlineFileName);
        examRecordForMarking.setObjectiveScore(0D);
        examRecordForMarking.setSubjectiveAnswerLength(0);
        examRecordForMarking.setBasePaperId(examRecordData.getBasePaperId());
        examRecordForMarking.setPaperType(examRecordData.getPaperType());
        examRecordForMarking.setUpdateTime(new Date());
        examRecordForMarkingRepo.save(examRecordForMarking);
	}
	
}
