package cn.com.qmth.examcloud.core.oe.student.service.impl;

import cn.com.qmth.examcloud.core.oe.student.bean.ExamSessionInfo;
import cn.com.qmth.examcloud.core.oe.student.service.ExamSessionInfoService;
import cn.com.qmth.examcloud.web.redis.RedisClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

/**
 * @author chenken
 * @date 2018/8/15 9:24
 * @company QMTH
 * @description 考试会话服务实现
 */
@Service("examSessionInfoService")
public class ExamSessionInfoServiceImpl implements ExamSessionInfoService {

    @Autowired
    private RedisClient redisClient;
    
    @Value("${exam_redis_key_prefix}")
    private String examRedisKeyPrefix;

    private static final Logger log = LoggerFactory.getLogger(ExamSessionInfoServiceImpl.class);

    @Override
    public void saveExamSessionInfo(Long studentId, ExamSessionInfo examSessionInfo, int timeout) {
        log.debug("11.4.1 进入开始保存考试会话方法，redisKey="+examRedisKeyPrefix+studentId);
        redisClient.set(examRedisKeyPrefix+studentId,examSessionInfo,timeout);
        ExamSessionInfo sessionInfo =redisClient.get(examRedisKeyPrefix+studentId,ExamSessionInfo.class);
        log.debug("11.4.2 保存考试会话方法完成，尝试取一下值 ="+sessionInfo.getExamRecordDataId());
    }

    @Override
    public ExamSessionInfo getExamSessionInfo(Long studentId) {
        return redisClient.get(examRedisKeyPrefix+studentId,ExamSessionInfo.class);
    }

    @Override
    public void deleteExamSessionInfo(Long studentId) {
        redisClient.delete(examRedisKeyPrefix+studentId);
    }
}
